<?php

namespace Modules\Pp\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;
class MachineryPlan extends Model
{
    protected $table = 'pp_machinery_plans';
    protected $primaryKey = 'machinery_plans_id';
    use HasFactory,LogsActivity;

    protected $fillable = [];
    protected static $logAttributes = [
        'machinery_plans_id',
        'customer_order_plan_data_id',
        'machinery_id',
        'product_primary_id',
        'date',
        'from',
        'to',
        'quantity',
        'shift_id',
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "pp_machinery_plans";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
    
    /*protected static function newFactory()
    {
        return \Modules\Pp\Database\factories\MachineryPlanFactory::new();
    }*/
}
