
var MACHINE_QUANTITY_PER_HOUR = 0;
var CUSTOMER_ORDER_PLAN_DATA_ID = undefined;
var PRODUCT_PRIMARY_ID = undefined;
var CUSTOMER_ORDER_PLAN_ID = undefined;
var FG_PRODUCT_ID = undefined;
var productChooser = null;
$(document).ready(function () {
    allOrderPlan();


    $('input[name="date"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        locale: {
            format: 'YYYY-MM-DD',
        }
    });

    $('input[name="date"]').on('change', function () {
        loadMachinePlan();
    });

    $('#cmbCustomerOrder').on('change', function () {
        var order_id = $(this).val();
        getOrderPlanData(order_id);
    });


    $('#cmbProduct').on('change', function () {
        var product_primary_id = $(this).val();
        var customer_order_plan_data_id = $('#cmbProduct option:selected').attr('data-id');

        getSelectedProductData(customer_order_plan_data_id, product_primary_id);
        factories();
        loadFactoryFilter();
        allShiftFilter();


        CUSTOMER_ORDER_PLAN_DATA_ID = customer_order_plan_data_id;
        PRODUCT_PRIMARY_ID = product_primary_id;
        FG_PRODUCT_ID = product_primary_id;
    });


    $("#cmbFactory").change(function () {

        loadMachinesToFactory(this.value, 'cmbMachine');
        clearAllocatedTable();
    });

    $("#cmbMachine").change(function () {
        MACHINE_QUANTITY_PER_HOUR = quantityPerHour(this.value);
        clearAllocatedTable();
        getAllocatedData(CUSTOMER_ORDER_PLAN_DATA_ID, PRODUCT_PRIMARY_ID, $(this).val());
    });


    $('#btnSaveMachintoProduct').on('click', function () {

        saveAllocateToMachine();
    });

    $('#cmbFactoryFilter').on('change', function () {
        loadMachinesToFactory(this.value, 'cmbMachineFilter');

    });

    $('#cmbMachineFilter').on('change', function () {
        loadMachinePlan();
    });

    $('#cmbShiftFilter').on('change', function () {
        loadMachinePlan();
    });

});


function clearAllocatedTable() {
    $('#tblAllocateProduct').empty();
    addMachineRow(0);
}


function allOrderPlan() {

    $.ajax({
        type: "GET",
        url: "/pp/allocateMachine/allOrderPlan",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            $('#cmbCustomerOrder').empty();
            $('#cmbCustomerOrder').append('<option selected disabled>--Select Here--</option>');
            if (response.data.success) {
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['customer_order_plan_id'];
                    order_id = response.data.result[i]['order_id'];
                    var trans_date = response.data.result[i]['trans_date'];
                    var delivery_date = response.data.result[i]['trans_date'];
                    var from_date = response.data.result[i]['from_date'];
                    var to_date = response.data.result[i]['to_date'];
                    var description = response.data.result[i]['description'];
                    var manufacturing_order_number = response.data.result[i]['manufacturing_order_number'];
                    var purchase_order = response.data.result[i]['purchase_order'];


                    $('#cmbCustomerOrder').append('<option value="' + id + '">' + manufacturing_order_number + ' - ' + purchase_order + '</option>');
                }


            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}




function getOrderPlanData(order_id) {

    $.ajax({
        type: "GET",
        url: "/pp/allocateMachine/allOrderPlanData/" + order_id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            showProgress();
        },
        success: function (response) {
            console.log(response);

            $('#cmbProduct').empty();
            $('#cmbProduct').append('<option selected disabled>--Select Here--</option>');
            if (response.data.success) {
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['customer_order_plan_data_id'];
                    var product_primary_id = response.data.result[i]['product_primary_id'];
                    var product_id = response.data.result[i]['product_id'];
                    var product_name = response.data.result[i]['product_name'];
                    var quantity = response.data.result[i]['quantity'];
                    var string_id = "'" + id + "'";
                    var string_product_id = "'" + product_primary_id + "'";
                    $('#cmbProduct').append('<option value="' + product_primary_id + '" data-id="' + id + '">' + product_id + ' - ' + product_name + '</option>');


                }



            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            hideProgress();
        }

    });

}



function getSelectedProductData(customer_order_plan_data_id, product_primary_id) {

    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/getSelectedProductData/' + customer_order_plan_data_id + "/" + product_primary_id + "/0",
        beforeSend: function () {
            showProgress();
        },
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {
                $('#lblProductCode').text(": " + response.data.result.product_code);
                $('#lblProductName').text(": " + response.data.result.product_name);
                $('#lblFactoryPO').text(": " + response.data.result.factory_po);
                $('#lblCustomerPO').text(": " + response.data.result.customer_po);
                $('#lblProductionQty').text(": " + response.data.result.quantity);
                $('#lblProductionQty').attr("data-id", response.data.result.quantity);
                $('#lblAllocateQty').text(": " + response.data.result.allocated_quantity);
                $('#lblAllocateQty').attr("data-id", response.data.result.allocated_quantity);
                $('#cmbFactory').trigger('change');
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {
            hideProgress();
        }
    });
}



function factories() {
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/factories',
        // async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {

                var html = '<option selected disabled>--Select Here--</option>';
                $('#cmbFactory').empty();
                $.each(response.data.result, function (index, value) {
                    html += '<option value="' + value.factory_id + '">' + value.name + '</option>';
                })
                $('#cmbFactory').html(html);
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}



function loadFactoryFilter() {
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/factories',
        //async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {

                var html = '<option selected disabled>--Select Here--</option>';
                html += '<option value="any">Any</option>';
                $('#cmbFactoryFilter').empty();
                $.each(response.data.result, function (index, value) {
                    html += '<option value="' + value.factory_id + '">' + value.name + '</option>';
                })
                $('#cmbFactoryFilter').html(html);
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}



function loadMachinesToFactory(factory_id, cmb_machine) {

    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/loadMachinesToFactory/' + factory_id,

        beforeSend: function () {

        },
        success: function (response) {
            console.log(response.result)
            if (response.success) {
                $('#' + cmb_machine).empty();
                $('#' + cmb_machine).append('<option selected disabled>--Select Here--</option>');
                if (cmb_machine == 'cmbMachineFilter') {
                    $('#' + cmb_machine).append('<option value="any">Any</option>');
                }
                var machine = response.result["machine"];
                for (i = 0; i < machine.length; i++) {
                    var id = machine[i]['machinery_id'];
                    var no = machine[i]['machinery_no'];
                    var name = machine[i]['machinery_name'];
                    var nn = no + "-" + name;
                    $('#' + cmb_machine).append('<option value="' + id + '">' + nn + '</option>');
                }


            }
            loadMachinePlan();
        }, error: function (data) {
            console.log('something went wrong');
        }
    });
}



/*function loadMachinesToFactoryFilter() {

    var factory_id = $('#cmbFactoryFilter').val();
    var machine_id = $('#cmbMachineFilter').val();
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/loadMachinesToFactory/' + factory_id + "/" + machine_id + "/" + $('#txtFromDateFilter').val() + "/" + $('#txtToDateFilter').val(),
        beforeSend: function () {
            showProgress();
        },
        success: function (response) {
            console.log(response.result)
            if (response.success) {
                $('#cmbMachineFilter').empty();
                $('#cmbMachineFilter').append('<option selected disabled>--Select Here--</option>');
                $('#cmbMachineFilter').append('<option value="any">Any</option>');
                $('#tblAvailableMachine').empty();

                var machine = response.result["machine"];
                for (i = 0; i < machine.length; i++) {
                    var machine_id = machine[i]['machinery_id'];
                    var no = machine[i]['machinery_no'];
                    var name = machine[i]['machinery_name'];
                    var factory = machine[i]['factory'];
                    var nn = no + "-" + name;
                    $('#cmbMachineFilter').append('<option value="' + machine_id + '">' + nn + '</option>');
                }

            }
            hideProgress();
        }, error: function (data) {
            console.log('something went wrong');
        }
    });
}*/




function loadMachinePlan() {

    var factory_id = $('#cmbFactoryFilter').val();
    var machine_id = $('#cmbMachineFilter').val();
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/loadMachinePlan/' + factory_id + "/" + machine_id + "/" + $('#txtFromDateFilter').val() + "/" + $('#txtToDateFilter').val(),
        beforeSend: function () {
            showProgress();
        },
        success: function (response) {
            console.log(response.result)
            if (response.success) {
                var nestedData = [];
                var machine = response.result["machine"];
                var allocated = response.result["allocated"];
                for (i = 0; i < machine.length; i++) {
                    var machine_id = machine[i]['machinery_id'];
                    var no = machine[i]['machinery_no'];
                    var name = machine[i]['machinery_name'];
                    var factory = machine[i]['factory'];
                    var nn = no + "-" + name;


                    var from_date_split = $('#txtFromDateFilter').val().split("-");
                    var to_date_split = $('#txtToDateFilter').val().split("-");
                    var from_date = (new Date(from_date_split[0], from_date_split[1], from_date_split[2]).getTime() / (24 * 3600 * 1000));
                    var to_date = (new Date(to_date_split[0], to_date_split[1], to_date_split[2]).getTime() / (24 * 3600 * 1000));


                    var machinePlan = [];
                    var shift = shiftArray();
                    for (i2 = from_date; i2 <= to_date; i2++) {
                        for (i3 = 0; i3 < shift.length; i3++) {
                            var date = new Date(i2 * (24 * 3600 * 1000));
                            var date_str = date.getFullYear() + "-" + appendZero("" + date.getMonth()) + "-" + appendZero("" + date.getDate());

                            var allocated_quantity = 0;
                            for (ii = 0; ii < allocated.length; ii++) {
                                if (allocated[ii]["date"] == date_str && machine_id == allocated[ii]["machinery_id"] && shift[i3]["shift_id"] == allocated[ii]["shift_id"]) {
                                    allocated_quantity = allocated[ii]["quantity"];

                                }
                            }




                            if ($('#cmbShiftFilter').val() == 'any' || $('#cmbShiftFilter').val() == null) {
                                machinePlan.push({
                                    machinery_id: machine_id,
                                    shift_id: shift[i3]["shift_id"],
                                    date: date_str,
                                    shift: shift[i3]["shift_name"],
                                    allocated: allocated_quantity,//getMachineAllocatedQuantity(machine_id, date_str),
                                });
                            } else if ($('#cmbShiftFilter').val() == shift[i3]["shift_id"]) {
                                machinePlan.push({
                                    machinery_id: machine_id,
                                    shift_id: shift[i3]["shift_id"],
                                    date: date_str,
                                    shift: shift[i3]["shift_name"],
                                    allocated: allocated_quantity,//getMachineAllocatedQuantity(machine_id, date_str),
                                });
                            }
                        }
                    }


                    nestedData.push({
                        factory: factory,
                        machine: nn,
                        machinePlan: machinePlan,
                    });
                }
                initTabulator(nestedData);
                hideProgress();

            }
        }, error: function (data) {
            console.log('something went wrong');
        }
    });
}




function getMachineAllocatedQuantity(machine_id, date) {

    var quantity = 0;
    $.ajax({
        type: 'GET',
        //async: false,
        url: '/pp/allocateMachine/getMachineAllocatedQuantity/' + machine_id + "/" + date,

        beforeSend: function () {

        },
        success: function (response) {
            console.log(response.result)




        }, error: function (data) {
            console.log('something went wrong');
        }
    });
    return quantity;
}


function appendZero(val) {

    if (val.length == 1) {
        val = "0" + val;
    }
    return val;
}



function addMachineRow(id) {
    $('#' + id).text("Remove");
    $('#' + id).attr('class', 'btn btn-danger remove');
    $('#' + id).attr('onclick', '');

    var btn_id = guidGenerator();
    var txtDate_id = "txtDate" + guidGenerator();
    var txtFrom_id = "txtFrom" + guidGenerator();
    var txtTo_id = "txtTo" + guidGenerator();
    var txtQty_id = "txtQty" + guidGenerator();
    var txtAllocatedQty_id = "allocatedQty" + guidGenerator();
    var txtOutput_id = "txtQty" + guidGenerator();
    var cmb_id = "cmb" + guidGenerator();

    var string_txtFrom_id = "'" + txtFrom_id + "'";
    var string_txtTo_id = "'" + txtTo_id + "'";
    var string_txtQty_id = "'" + txtQty_id + "'";
    var string_txtOutput_id = "'" + txtOutput_id + "'";
    var string_id = "'" + btn_id + "'";

    var row = '<tr id="' + id + '"><td><input id="' + txtDate_id + '" data-id="' + txtAllocatedQty_id + '" data-id2="' + txtFrom_id + '" data-id3="' + txtTo_id + '" type="text" class="form-control-sm" style="width:130px; border:1px solid gray;" name="dteDate" id="dteDate" autocomplete="off"></td>';
    row += '<td><input id="' + txtFrom_id + '" type="text" class="form-control-sm" style="width:80px; border:1px solid gray;" autocomplete="off" oninput="calculateOutput(' + string_txtFrom_id + ',' + string_txtTo_id + ',' + string_txtQty_id + ',' + string_txtOutput_id + ')"></td>';
    row += '<td><input id="' + txtTo_id + '" type="text" class="form-control-sm" style="width:80px; border:1px solid gray;" autocomplete="off" oninput="calculateOutput(' + string_txtFrom_id + ',' + string_txtTo_id + ',' + string_txtQty_id + ',' + string_txtOutput_id + ')"></td>';
    row += '<td><input id="' + txtQty_id + '" type="text" class="form-control-sm newQty" style="width:100px;text-align:right; border:1px solid gray;"  autocomplete="off" oninput="isCapacityExeeded(' + string_txtQty_id + ',' + string_txtOutput_id + ');validate_to_allocatedQty_to_productionQty()"></td>';
    row += '<td><input id="' + txtOutput_id + '" type="text" class="form-control-sm" style="width:100px;text-align:right; border:1px solid gray;" id="date" autocomplete="off" oninput="isCapacityExeeded(' + string_txtQty_id + ',' + string_txtOutput_id + ');"></td>';
    row += '<td><input id = "' + txtAllocatedQty_id + '" type="text" class="form-control-sm" style="width:100px; border:1px solid gray;" id="date" autocomplete="off"></td>';
    row += '<td><select id="' + cmb_id + '" class="form-control" style="width:200px;"></select></td>';
    row += '<td><button type="button" id="' + btn_id + '" class="btn btn-primary" onclick="addMachineRow(' + string_id + ')">Add</button></td></tr>';
    $('#tblAllocateProduct').append(row);

    $(".remove").click(function () {
        $(this).closest("tr").remove();
    });

    $('input[name="dteDate"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        locale: {
            format: 'YYYY-MM-DD',
        }
    });
    $('#' + txtDate_id).val('');
    $('input[name="dteDate"]').on('apply.daterangepicker', function (ev, picker) {
        var from = $('#' + $(this).attr('data-id2')).val();
        var to = $('#' + $(this).attr('data-id3')).val();
        var allocatedQty = getAllocatedQuantityFromDate(CUSTOMER_ORDER_PLAN_DATA_ID, PRODUCT_PRIMARY_ID, $('#cmbMachine').val(), $(this).val(), from, to);
        $('#' + $(this).attr('data-id')).val(allocatedQty);


    });


    $('#' + cmb_id).on('change', function () {
        get_from_to($(this).val(), txtFrom_id, txtTo_id);
    });

    allShift(cmb_id);
    return {
        "btn_id": btn_id,
        "date": $('#' + txtDate_id),
        "from": $('#' + txtFrom_id),
        "to": $('#' + txtTo_id),
        "quantity": $('#' + txtQty_id),
        "output": $('#' + txtOutput_id),
        "allocate": $('#' + txtAllocatedQty_id),
        "shift": $('#' + cmb_id),

    };

}


function guidGenerator() {
    var S4 = function () {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    };
    return (S4() + S4());
}



function allShift(id) {
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/allShift',
        async: false,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {

                var html = '';
                $.each(response.data.result, function (index, value) {
                    html += '<option value="' + value.shift_id + '">' + value.shift_name + '</option>';
                })
                $('#' + id).html(html);
                $('#' + id).change();
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}



function allShiftFilter() {
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/allShift',
        async: false,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {

                var html = '<option selected disabled>--Select Here--</option>';
                html += '<option value="any">Any</option>';
                $.each(response.data.result, function (index, value) {
                    html += '<option value="' + value.shift_id + '">' + value.shift_name + '</option>';
                })
                $('#cmbShiftFilter').html(html);
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}


function shiftArray() {
    var shift = [];
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/allShift',
        async: false,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {
                $.each(response.data.result, function (index, value) {
                    shift.push({ "shift_id": value.shift_id, "shift_name": value.shift_name });
                });
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
    return shift;
}


function get_from_to(shift_id, from_id, to_id) {


    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/get_from_to/' + shift_id,
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {
                $('#' + from_id).val(response.data.result.from);
                $('#' + to_id).val(response.data.result.to);

            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}



function quantityPerHour(machine_id) {
    var quantity = 0;
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/quantityPerHour/' + machine_id + "/" + PRODUCT_PRIMARY_ID,
        async: false,
        success: function (response) {
            console.log(response.data.result);
            quantity = response.data.result;
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
    return quantity;
}



function getAllocatedData(order_id, product_id, machine_id) {

    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/getAllocatedData/' + order_id + "/" + product_id + "/" + machine_id,
        //async: false,
        beforeSend: function () {
            showProgress();
        },
        success: function (response) {
            console.log(response.data.result);
            var result = response.data.result;
            if (result.length > 0) {
                var childarray = { "btn_id": 0 };
                $('#tblAllocateProduct').empty();
                for (var i = 0; i < result.length; i++) {

                    childarray = addMachineRow(childarray.btn_id);
                    childarray.date.val(result[i].date);
                    childarray.from.val(result[i].from);
                    childarray.to.val(result[i].to).trigger("input");
                    childarray.quantity.val(result[i].quantity);
                    childarray.quantity.attr("class", "form-control-sm oldQty");
                    childarray.shift.val(result[i].shift_id);
                    childarray.date.trigger('apply.daterangepicker');

                }
                addMachineRow(childarray.btn_id);

            }

        },
        error: function (data) {

        },
        complete: function () {
            hideProgress();
        }
    });

}



function getAllocatedQuantityFromDate(order_id, product_id, machine_id, date, from, to) {

    var quantity = 0;
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/getAllocatedQuantityFromDate/' + order_id + "/" + product_id + "/" + machine_id + "/" + date + "/" + from + "/" + to,
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.result != null) {
                quantity = response.data.result;
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
    return quantity;
}


function calculateOutput(from_id, to_id, qty_id, output_id) {

    var from = $('#' + from_id).val();
    var to = $('#' + to_id).val();
    var qty = $('#' + qty_id).val();
    var output = (to - from) * MACHINE_QUANTITY_PER_HOUR;
    if (output < 0) {
        output = 0;
    }
    $('#' + output_id).val(output);

}


function isCapacityExeeded(qty_id, output_id) {

    var qty = parseFloat($('#' + qty_id).val());
    var output = parseFloat($('#' + output_id).val());

    if (qty > output) {
        //showWarningMessage('Maximum capacity exeeded.');
        showWarningMessage("Maximum capacity exeeded.<br>Quantity :" + qty + "<br>Max Output Qty :" + output);

    }
}



function validate_to_allocatedQty_to_productionQty() {

    var allocated_qty = parseFloat($('#lblAllocateQty').attr('data-id'));
    var production_qty = parseFloat($('#lblProductionQty').attr('data-id'));
    var qty_array = $('.newQty').map((_, el) => el.value).get();
    var new_allocated_qty = 0;
    for (var i = 0; i < qty_array.length; i++) {
        new_allocated_qty += parseFloat(qty_array[i]);
    }
    if (parseFloat(allocated_qty + new_allocated_qty) > production_qty) {
        showWarningMessage("Maximum capacity exeeded.<br>Production Qty :" + production_qty + "<br>Allocated Qty :" + parseFloat(allocated_qty + new_allocated_qty));
    }


}




function saveAllocateToMachine() {

    console.log(dataSource());
    $.ajax({
        type: "POST",
        url: '/pp/allocateMachine/saveAllocateToMachine',
        data: {
            "customer_order_plan_data_id": CUSTOMER_ORDER_PLAN_DATA_ID,
            'machinery_id': $('#cmbMachine').val(),
            "product_primary_id": PRODUCT_PRIMARY_ID,
            'data': dataSource(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage('Data has been saved successful');
                clearAllocatedTable();
                $('#cmbMachine').prop('selectedIndex', 0);
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {
            $('#allocateMachineModal').modal('hide');
        }

    });
}



function dataSource() {

    var collection = {};
    var table = document.getElementById('tblAllocateProduct'),
        rows = table.getElementsByTagName('tr'),
        i, j, cells, customerId;

    for (i = 0, j = rows.length; i < j; ++i) {
        cells = rows[i].getElementsByTagName('td');
        if (!cells.length) {
            continue;
        }
        var data = {
            "date": cells[0].childNodes[0].value,
            "from": cells[1].childNodes[0].value,
            "to": cells[2].childNodes[0].value,
            "quantity": cells[3].childNodes[0].value,
            "output": cells[4].childNodes[0].value,
            "allocated": cells[5].childNodes[0].value,
            "shift": cells[6].childNodes[0].value,
        };
        collection[i] = JSON.stringify(data);



    }

    return collection;

};




/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}






function initTabulator(nestedData) {





    //define table
    var table = new Tabulator("#example-table", {
        height: "20000px",
        layout: "fitColumns",
        columnDefaults: {
            resizable: false,
        },
        data: nestedData,
        columns: [{
            title: "Factory",
            field: "factory"
        },
        {
            title: "Machine",
            field: "machine"
        }],
        rowFormatter: function (row) {
            //create and style holder elements
            var holderEl = document.createElement("div");
            var tableEl = document.createElement("div");

            holderEl.style.boxSizing = "border-box";
            holderEl.style.padding = "10px 30px 10px 10px";
            holderEl.style.borderTop = "1px solid #333";
            holderEl.style.borderBotom = "1px solid #333";


            tableEl.style.border = "1px solid #333";

            holderEl.appendChild(tableEl);

            row.getElement().appendChild(holderEl);

            var subTable = new Tabulator(tableEl, {
                //layout: "fitColumns",
                data: row.getData().machinePlan,
                columns: [{
                    title: "Date",
                    field: "date",
                },
                {
                    title: "Shift",
                    field: "shift"
                },
                {
                    title: "Allocated",
                    field: "allocated"
                },
                ]
            });
            subTable.on("rowClick", function (e, row) {
                var data = row.getData();
                $('#lbl_customer_order').text($('#cmbCustomerOrder option:selected').text());
                $('#lbl_product_code').text($('#lblProductCode').text());
                $('#lbl_product_name').text($('#lblProductName').text());
                $('#lbl_shift').text(data.shift);
                $('#lbl_allocated_quantity').text(data.allocated);
                getAllocatedQuantityData(data.machinery_id, data.shift_id, data.date)
                $('#allocateMachineModal').modal('toggle');
                //alert(data.shift+" - "+data.allocated);
            });
        },
    });


    table.on("rowClick", function (e, row) {
        var data = row.getData();
        //alert(data.factory+" - "+data.machine);
    });
}



function getAllocatedQuantityData(machine_id, shift_id, date) {


    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/getAllocatedQuantityData/' + machine_id + "/" + shift_id + "/" + date,
        async: false,
        success: function (response) {
            var data = response.data.result;
            console.log(response.data.result);
            $('#tblAllocatedQuantityData').empty();
            for (var i = 0; i < data.length; i++) {
                var from_to = data[i].from + ' - ' + data[i].to;
                var quantity = data[i].quantity;
                $('#tblAllocatedQuantityData').append('<tr><td>' + from_to + '</td><td>' + quantity + '</td></tr>');
            }

        },
        error: function (data) {

        },
        complete: function () {

        }
    });

}

