$(document).ready(function () {
    allFactories();

    $('#selcMachine').prop("disabled", true);
    $('#selcCompany').prop("disabled", true);




    $('input[name="startDate"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        locale: {
            format: 'YYYY-MM-DD',
        }

    });
    $('input[name="startDate"]').on('apply.daterangepicker', function (ev, picker) {

    });

    $('input[name="endDate"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        locale: {
            format: 'YYYY-MM-DD',
        }

    });
 



    $('#checkCompanySearch').change(function () {
        allMachineries();
        var bool = $(this).is(":checked");
        if (bool) {
            $('#selcCompany').prop("disabled", false);
        } else {
            $('#selcCompany').prop("disabled", true);
        }
    });


    $('#checkMachineSearch').change(function () {
        allMachineries();
        var bool = $(this).is(":checked");
        if (bool) {
            $('#selcMachine').prop("disabled", false);
        } else {
            $('#selcMachine').prop("disabled", true);
        }
    });


    $('#selcCompany').on('change', function () {
        allMachineries();
    });


    $('#btnPrint').on('click', function () {
        previewReport();
    });

    $('#btnExport').on('click', function () {
        exportReport();
    });
});


function allFactories() {
    $.ajax({
        type: 'GET',
        url: '/pp/allocateMachine/factories',
        // async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {

                var html = '<option selected disabled>--Select Here--</option>';
                $('#selcCompany').empty();
                $.each(response.data.result, function (index, value) {
                    html += '<option value="' + value.factory_id + '">' + value.name + '</option>';
                })
                $('#selcCompany').html(html);
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}



function allMachineries() {


    $.ajax({
        type: "GET",
        url: "/pp/allocateMachine/loadMachinesToFactory/" + $('#selcCompany').val(),
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            var machine = response.result.machine;
            $('#selcMachine').empty();
            for (var i = 0; i < machine.length; i++) {
                $('#selcMachine').append('<option value="' + machine[i].machinery_id + '">' + machine[i].machinery_no + '</option>');
            }

            if (machine.length == 0) {
                $('#selcMachine').prop("disabled", true);
                $("#checkMachineSearch").prop('checked', false);
            }

        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
}



function previewReport() {
    if ($('#cmbReport').val() == null) {
        showWarningMessage("Please select report");
    } else if ($('#cmbReport').val() == 1) {
        previewProductionPlanReport();
    }
}

function exportReport() {
    if ($('#cmbReport').val() == null) {
        showWarningMessage("Please select report");
    } else if ($('#cmbReport').val() == 1) {
        exportProductionPlanReport();
    }
}



function previewProductionPlanReport() {

    var factory = null;
    var machine = null;
    if ($('#checkCompanySearch').is(':checked')) {
        factory = $('#selcCompany').val();
    }
    if ($('#checkMachineSearch').is(':checked')) {
        machine = $('#selcMachine').val();
    }
    var date_from = $('#txtDateFrom').val();
    var date_to = $('#txtDateTo').val();
    var url = "/pp/ProductionReport/previewProductionPlanReport/" + factory + "/" + machine + "/" + date_from + "/" + date_to;
    window.open(url, '_blank');

}


function exportProductionPlanReport() {

    var factory = null;
    var machine = null;
    if ($('#checkCompanySearch').is(':checked')) {
        factory = $('#selcCompany').val();
    }
    if ($('#checkMachineSearch').is(':checked')) {
        machine = $('#selcMachine').val();
    }
    var date_from = $('#txtDateFrom').val();
    var date_to = $('#txtDateTo').val();
    location.href = "/pp/exportProductionPlanExcel/" + factory + "/" + machine + "/" + date_from + "/" + date_to;
}




/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {

    toastr.success(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}


/**
* showWarrningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {

    toastr.warning(message);
}