@extends('pp::layouts.app')

@section('head')
<!-- DataTable -->
<link rel="stylesheet" href="{{ url('vendors/dataTable/datatables.min.css') }}" type="text/css">
<link rel="stylesheet" href="{{ url('vendors/datepicker/daterangepicker.css') }}" type="text/css">
<!-- Prism -->
<link rel="stylesheet" href="{{ url('vendors/prism/prism.css') }}" type="text/css">
<link rel="stylesheet" href="{{ Module::asset('hr:css/hr/employee.css') }}" type="text/css">
<link rel="stylesheet" href="{{ Module::asset('hr:js/autocomplete2/css/autocomplete.min.css') }}">
<link rel="stylesheet" href="{{ Module::asset('hr:css/hr/settings.css') }}" media="all" type="text/css" />
<meta name="csrf-token" content="{{ csrf_token() }}">



@endsection

@section('content')

<div class="page-header">
    <div>
        <h3></h3>
        <nav aria-label="breadcrumb">
            <ol class="breadcrumb">
                <li class="breadcrumb-item">
                    <a href="#">Home</a>
                </li>
                <li class="breadcrumb-item">
                    <a href="#">Pages</a>
                </li>
                <li class="breadcrumb-item active" aria-current="page">Form Page</li>
            </ol>
        </nav>
    </div>
</div>

<div class="row">
    <div class="col-md-12">
        <div class="card ">

            <div class="card-body">
                <h6 class="card-title">Machinery product</h6>
                <div id="bomHeader">
                    {{-- <div>
                        <button onclick="showModelAddBOMHeader()" class="btn btn-primary mr-5" name="addbomheadermodel" id="btnAddbomHeaderModel" type="button">Add Bill Of Material</button>
                    </div> --}}

                    <br>

                    <div class="row" id='rowbomHeaderTable'>
                        <div class="col-md-12">
                            <div class="table-responsive">
                                <!-- Required for Responsive -->
                                <table id="myTable" class="table datatable">
                                    <thead>
                                        <tr>
                                            <th>ID</th>
                                            <th>Machinery id</th>
                                            <th>Machinery name</th>
                                            <th>Site Name</th>
                                        </tr>
                                    </thead>
                                    <tbody>

                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
                <br>
                <div id="bomData">
                    <div>
                        @if(Auth::user()->can('pp_machines_assign_product_add_product_machine'))
                        <button class="btn btn-primary mr-5 mt-5" name="addbomdatamodel" id="btnProduct" type="button">Add Product to Machine</button>
                        @endif
                    </div>

                    <br>

                    <div class="row" id='rowBottomTable'>
                        <div class="col-md-12">
                            <div class="table-responsive">
                                <!-- Required for Responsive -->
                                <table id="machinaryProductTable" class="table table-striped  datatable">
                                    <thead>
                                        <tr>
                                            <th>Product ID</th>
                                            <th>Product Name</th>
                                            <th>Machine Name</th>
                                            <th>QTY / Hour</th>
                                            <th>Edit</th>
                                            <th>delete</th>
                                            <th>status</th>
                                        </tr>
                                    </thead>
                                    <tbody>

                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>

                </div>

            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="productModel" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="settingsAddModalTitle">Assign Product</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <i class="ti-close"></i>
                </button>
            </div>
            <form method="POST" id="machinary_productfrm">
                {{csrf_field()}}
                <input type="hidden" id="machineryId" name="machinery_id" value>
                <input type="hidden" id="machinery_product_id" name="machinery_product_id" value>

                <div class="modal-body" id="settingsAddModalBody">

                    <div class="form-row">
                        <label for="txtUpGrpLevel">Product Name</label>
                        <select class="form-control" id="product_nameDropDown" name="product_Id"></select>
                    </div>
                    <div class="form-row">
                        <label for="txtUpGrpLevel">Unit Of Mesurement</label>
                        <select class="form-control" id="txtUnitOfMesurement" name="umo"></select>
                    </div>
                    <div class="form-row">
                        <div class="col-md-12 mb-3">
                            <label for="txtName">Quantity per hours</label>
                            <input type="text" class="form-control" name="quantity" id="quantity" placeholder="Quantity" required="">
                        </div>
                    </div>
                    <div class="form-row">
                        <div class="col-md-12 mb-3">
                            <label for="txtName">Wastage.(%)</label>
                            <input type="text" class="form-control" name="wastage" id="wastage" placeholder="Wastage" required="">
                        </div>
                    </div>


                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-danger" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary" id="btnSaveProduct">Save</button>
                </div>
            </form>
        </div>
    </div>
</div>


@endsection

<!-- App scripts -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
@section('script')
<!-- DataTable -->
<script src="{{ url('vendors/dataTable/datatables.min.js') }}"></script>
<script src="{{ url('assets/js/examples/datatable.js') }}"></script>
<script src="{{ Module::asset('hr:js/autocomplete2/js/autocomplete.min.js') }}"></script>
<!-- Javascript -->
<script src="{{ url('vendors/datepicker/daterangepicker.js') }}"></script>
<script src="{{ Module::asset('pp:js/pp_machinery_product.js') }}?random=<?php echo uniqid(); ?>"></script>

<!-- Prism -->
<script src="{{ url('vendors/prism/prism.js') }}"></script>
<!-- Sweet alert -->
<script src="{{ url('assets/js/examples/sweet-alert.js') }}"></script>
@endsection